import java.util.*;

/**
 * The test suite for the US map exploration and Lab 11 Sping 2007
 * 
 * @author Viera K. Proulx
 *
 */
public class Examples extends SimpleTestHarness{
  
  /** data for the methods and tests */
  HashMap<City, State> newEngland = new HashMap<City, State>();
  ArrayList<String> NHneighbors = new ArrayList<String>();
  ArrayList<String> VTneighbors = new ArrayList<String>();
  ArrayList<String> MEneighbors = new ArrayList<String>();
  ArrayList<String> MAneighbors = new ArrayList<String>();
  ArrayList<String> RIneighbors = new ArrayList<String>();
  ArrayList<String> CTneighbors = new ArrayList<String>();
  
  City concord = new City("03301", "Concord", "NH", 71.527734, 43.218525);
  City montpellier = new City("05602", "Montpelier", "VT", 72.576992, 44.264082);
  City augusta = new City("04330", "Augusta", "ME", 69.766548, 44.323228);
  City boston = new City("02115", "Boston", "MA", 71.092215, 42.342706);
  City providence = new City("02908", "Providence", "RI", 71.437684, 41.838294);
  City hartford = new City("06120", "Hartford", "CT", 72.675807, 41.78596);

  
  State NH = new State("NH", concord, NHneighbors );
  State VT = new State("VT", montpellier, VTneighbors );
  State ME = new State("ME", augusta, MEneighbors );
  State MA = new State("MA", boston, MAneighbors );
  State RI = new State("RI", providence, RIneighbors );
  State CT = new State("CT", hartford, CTneighbors );
  
  
  /** generate lists of neighboring states */
  public void makeNewEngland(){
    NHneighbors.add("ME");
    NHneighbors.add("MA");
    NHneighbors.add("VT");
    
    VTneighbors.add("NH");
    VTneighbors.add("MA");

    MEneighbors.add("NH");

    MAneighbors.add("NH");
    MAneighbors.add("VT");
    MAneighbors.add("CT");
    MAneighbors.add("RI");

    RIneighbors.add("MA");
    RIneighbors.add("CT");

    CTneighbors.add("MA");
    CTneighbors.add("RI");
  }
  
  /** generate New England states */
  public void makeStates(){
    
    newEngland.put(concord, NH);
    newEngland.put(montpellier, VT);
    newEngland.put(augusta, ME);
    newEngland.put(boston, MA);
    newEngland.put(providence, RI);
    newEngland.put(hartford, CT);
    
    City boston2 = new City("02115", "Boston", "MA", 71.092215, 42.342706);
    newEngland.put(boston2, MA);
  }

  
  /**
   * The test driver
   */
  public void runTests(){
    this.makeNewEngland();
    this.makeStates();
    
    System.out.println("Concord: " + newEngland.get(concord));
    System.out.println("Montpellier: " + newEngland.get(montpellier));
    System.out.println("Augusta: " + newEngland.get(augusta));
    System.out.println("Boston: " + newEngland.get(boston));
    System.out.println("Providence: " + newEngland.get(providence));
    System.out.println("Hartford: " + newEngland.get(hartford));
   
    test("map size:", newEngland.size(), 6);
    
    State st = newEngland.get(concord);
  
    test("same state method -- should succeed: ", 
        st, 
        NH);
  
    testReport();
    fullTestReport();
  }
  
  
}