
import java.util.ArrayList;
import java.util.NoSuchElementException;

/**
 * @(#)TraversalALC< 27 March 2006
 * A non-mutable iterator for an ArrayList of E
 * @author Viera K. Proulx
 */
public class TraversalALC<E> implements Traversal<E>{
  ArrayList<E> arrlist;
  int index;
  
  /**
   * constructor to initiate traversal at the given index
   * @param arrlist the <CODE>ArrayList</CODE> to traverse
   * @param index the index where to start traversal
   * @see #TraversalALC(ArrayList<E>)
   */
  public TraversalALC(ArrayList<E> arrlist, int index){
    if (index >= 0 && index <= arrlist.size()){
    this.arrlist = arrlist;
    this.index = index;
    }
    else
      throw new IndexOutOfBoundsException("In TraversalALC constructor");
  }
  
  /**
   * constructor to initiate traversal at the beginning
   * @param arrlist
   * @see #TraversalALC(ArrayList<E>, int)
   */
  public TraversalALC(ArrayList<E> arrlist){
    this(arrlist, 0);
  }
  
  /**------------------------------------------------------
  Methods to implement the Traversal interface
  *------------------------------------------------------*/

  /**
   * move the cursor one forward, if not at the end 
   * @return new traversal advanced to the next element
   * @throws <CODE>NoSuchElementException</CODE> when no element is available
   */
  public Traversal<E> getRest() throws IllegalUseOfTraversalException{
    if (!this.isEmpty())
      return new TraversalALC<E>(this.arrlist, this.index + 1);
    else
      throw new IllegalUseOfTraversalException(
      "Cannot advance beyond the last element in ArrayList");
  }
  
  /* select the item to which the cursor points */
  /**
   * produce the first element in the collection, if not at the end 
   * @return first element in the collection
   * @throws <CODE>NoSuchElementException</CODE> when no element is available
   */
  public E getFirst() throws IllegalUseOfTraversalException{
    if (!this.isEmpty())
      return this.arrlist.get(this.index);
    else
      throw new IllegalUseOfTraversalException(
      "No current element after the last element in ArrayList");
  }
  
  /**
   * is there an element in thic collection?
   * @return true if no element is available
   */
  public boolean isEmpty(){
    return this.index == arrlist.size();
  }
  
  /**
   * self test
   * @param argv
   */
  public static void main(String argv[]){
   
    ArrayList<String> empty = new ArrayList<String>();
    ArrayList<String> alist = new ArrayList<String>();
    alist.add("northville");
    alist.add("pinckney");
    alist.add("plymouth");
    alist.add("plymouth2");
    
    System.out.println("Examples of CitiesList-s:");
    Traversal tr = new TraversalALC<String>(alist);

    System.out.println("The list:");   
    while (!tr.isEmpty()){
      try{
      System.out.println(tr.getFirst());
      tr = tr.getRest(); 
      }
      catch(IllegalUseOfTraversalException e){
        System.out.println("" + e.getMessage());
      }
    }
    /** now the program would fail - but we catch the exception */
    try{
      System.out.println(tr.getFirst());
      tr = tr.getRest(); 
      }
      catch(IllegalUseOfTraversalException e){
        System.out.println("ERROR: " + e.getMessage());
      }
    System.out.println("End of the list.");
  }
  
}

